﻿using System;
using System.Collections.Generic;
using CitizenFX.Core;
using CitizenFX.Core.Native;
using static CitizenFX.Core.Native.API;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace LCARS_Scaleform
{
    public class Client : BaseScript
    {
        string url = "https://w.soundcloud.com/player/?url=" +
   "https%3A//api.soundcloud.com/tracks/467725488&color=%23ff5500&auto_play=true" +
   "&hide_related=false&show_comments=true&show_user=true&show_reposts=false&show_teaser=true&visual=true";
        float scale = 0.1f;
        string sfName = "generic_texture_renderer";

        int width = 1280;
        int height = 720;

        int sfHandle = 0;
        bool txdHasBeenSet = false;
        long duiObj = 0;

        long txd;

        public Client()
        {
            EventHandlers["onClientResourceStart"] += new Action<string>(OnClientResourceStart);
            EventHandlers["onClientResourceStop"] += new Action<string>(OnClientResourceStop);
            Tick += LoopFunc;
        }
        async void OnClientResourceStart(string resourceName)
        {
            if (GetCurrentResourceName() != resourceName) return;
            sfHandle = RequestScaleformMovie(sfName);
            if (!HasScaleformMovieLoaded(sfHandle))
            {
                await Delay(1000);
            }
            txd = CreateRuntimeTxd("texDict");
            duiObj = CreateDui(url, width, height);
            string dui = GetDuiHandle(duiObj);
            CreateRuntimeTextureFromDuiHandle(txd, "texName", dui);
            SetDuiUrl(duiObj, url);
            await Delay(0);
        }

        async Task LoopFunc()
        {
            Vector3 pos = Game.PlayerPed.Position;
            if (sfHandle != 0 && !txdHasBeenSet)
            {
                BeginScaleformMovieMethod(sfHandle, "SET_TEXTURE");

                PushScaleformMovieMethodParameterString("texDict"); // txd
                PushScaleformMovieMethodParameterString("texName"); // txn
                
                ScaleformMovieMethodAddParamInt(0); // x
                ScaleformMovieMethodAddParamInt(0); // y
                ScaleformMovieMethodAddParamInt(width);
                ScaleformMovieMethodAddParamInt(height);

                EndScaleformMovieMethod();

                txdHasBeenSet = true;
            }
            if (sfHandle != 0 && HasScaleformMovieLoaded(sfHandle))
            {
                DrawScaleformMovie_3dNonAdditive(
                sfHandle,
                pos[0] -1 , pos[1], pos[2] - 2,
                0, 180, 0,
                2, 2, 2,
                scale * 1, scale * (9 / 16), 1,
                2);
            }
        await Task.FromResult(0);
    }
        async void OnClientResourceStop(string resourceName)
        {
            
            await Delay(0);
        }
    }
}